from xml.etree import ElementTree as ET

from explorecourses import *

class TestCourse(object):

    @classmethod
    def setup_class(cls):
        text_math19 = (
            '<course>'
            '<year>2017-2018</year>'
            '<subject>MATH</subject>'
            '<code>19</code>'
            '<title>Calculus</title>'
            '<description>'
            'Introduction to differential calculus of functions of one '
            'variable. Review of elementary functions (including exponentials '
            'and logarithms), limits, rates of change, the derivative and its '
            'properties, applications of the derivative. Prerequisites: '
            'trigonometry, advanced algebra, and analysis of elementary '
            'functions (including exponentials and logarithms). You must have '
            'taken the math placement diagnostic (offered through the Math '
            'Department website) in order to register for this course.'
            '</description>'
            '<gers>GER:DB-Math, WAY-FR</gers>'
            '<repeatable>false</repeatable>'
            '<grading>Letter or Credit/No Credit</grading>'
            '<unitsMin>3</unitsMin>'
            '<unitsMax>3</unitsMax>'
            '<learningObjectives>'
            '<learningObjective>'
            '<requirementCode>WAY-FR</requirementCode>'
            '<description>'
            'solve equations or optimization problems through translation to a '
            'standardized formalism.'
            '</description>'
            '</learningObjective>'
            '</learningObjectives>'
            '<sections>'
            '<section>'
            '<classId>14552</classId>'
            '<term>2017-2018 Autumn</term>'
            '<termId>1182</termId>'
            '<subject>MATH</subject>'
            '<code>19</code>'
            '<units>3</units>'
            '<sectionNumber>04</sectionNumber>'
            '<component>LEC</component>'
            '<numEnrolled>29</numEnrolled>'
            '<maxEnrolled>55</maxEnrolled>'
            '<numWaitlist>0</numWaitlist>'
            '<maxWaitlist>0</maxWaitlist>'
            '<enrollStatus>Open</enrollStatus>'
            '<addConsent>N</addConsent>'
            '<dropConsent>N</dropConsent>'
            '<courseId>117227</courseId>'
            '<schedules>'
            '<schedule>'
            '<startDate>Sep 25, 2017</startDate>'
            '<endDate>Dec 8, 2017</endDate>'
            '<startTime>1:30:00 PM</startTime>'
            '<endTime>2:20:00 PM</endTime>'
            '<location>380-380C</location>'
            '<days>'
            'Monday Wednesday Friday'
            '</days>'
            '<instructors>'
            '<instructor>'
            '<name>Kimport, S.</name>'
            '<firstName>Susie</firstName>'
            '<middleName/>'
            '<lastName>Kimport</lastName>'
            '<sunet>skimport</sunet>'
            '<role>GP</role>'
            '</instructor>'
            '<instructor>'
            '<name>Lolas, P.</name>'
            '<firstName>Panagiotis</firstName>'
            '<middleName/>'
            '<lastName>Lolas</lastName>'
            '<sunet>panagd</sunet>'
            '<role>TA</role>'
            '</instructor>'
            '<instructor>'
            '<name>Falcone, P.</name>'
            '<firstName>Paul</firstName>'
            '<middleName>William</middleName>'
            '<lastName>Falcone</lastName>'
            '<sunet>pwfalcon</sunet>'
            '<role>TA</role>'
            '</instructor>'
            '<instructor>'
            '<name>Izzo, Z.</name>'
            '<firstName>Zachary</firstName>'
            '<middleName/>'
            '<lastName>Izzo</lastName>'
            '<sunet>zizzo</sunet>'
            '<role>TA</role>'
            '</instructor>'
            '<instructor>'
            '<name>Sprunger, C.</name>'
            '<firstName>Carsten</firstName>'
            '<middleName/>'
            '<lastName>Sprunger</lastName>'
            '<sunet>csprun</sunet>'
            '<role>TA</role>'
            '</instructor>'
            '<instructor>'
            '<name>Mueller, S.</name>'
            '<firstName>Stefan</firstName>'
            '<middleName/>'
            '<lastName>Mueller</lastName>'
            '<sunet>smu3ll3r</sunet>'
            '<role>PI</role>'
            '</instructor>'
            '</instructors>'
            '</schedule>'
            '</schedules>'
            '<currentClassSize>29</currentClassSize>'
            '<maxClassSize>55</maxClassSize>'
            '<currentWaitlistSize>0</currentWaitlistSize>'
            '<maxWaitlistSize>0</maxWaitlistSize>'
            '<notes/>'
            '<attributes>'
            '<attribute>'
            '<name>NQTR</name>'
            '<value>WIN</value>'
            '<description>Winter</description>'
            '<catalogPrint>true</catalogPrint>'
            '<schedulePrint>false</schedulePrint>'
            '</attribute>'
            '<attribute>'
            '<name>NQTR</name>'
            '<value>SUM</value>'
            '<description>Summer</description>'
            '<catalogPrint>true</catalogPrint>'
            '<schedulePrint>false</schedulePrint>'
            '</attribute>'
            '<attribute>'
            '<name>NQTR</name>'
            '<value>AUT</value>'
            '<description>Autumn</description>'
            '<catalogPrint>true</catalogPrint>'
            '<schedulePrint>false</schedulePrint>'
            '</attribute>'
            '</attributes>'
            '</section>'
            '<section>'
            '<classId>14244</classId>'
            '<term>2017-2018 Autumn</term>'
            '<termId>1182</termId>'
            '<subject>MATH</subject>'
            '<code>19</code>'
            '<units>3</units>'
            '<sectionNumber>03</sectionNumber>'
            '<component>LEC</component>'
            '<numEnrolled>37</numEnrolled>'
            '<maxEnrolled>55</maxEnrolled>'
            '<numWaitlist>0</numWaitlist>'
            '<maxWaitlist>0</maxWaitlist>'
            '<enrollStatus>Open</enrollStatus>'
            '<addConsent>N</addConsent>'
            '<dropConsent>N</dropConsent>'
            '<courseId>117227</courseId>'
            '<schedules>'
            '<schedule>'
            '<startDate>Sep 25, 2017</startDate>'
            '<endDate>Dec 8, 2017</endDate>'
            '<startTime>11:30:00 AM</startTime>'
            '<endTime>12:20:00 PM</endTime>'
            '<location>380-380C</location>'
            '<days>'
            'Monday Wednesday Friday'
            '</days>'
            '<instructors>'
            '<instructor>'
            '<name>Kimport, S.</name>'
            '<firstName>Susie</firstName>'
            '<middleName/>'
            '<lastName>Kimport</lastName>'
            '<sunet>skimport</sunet>'
            '<role>GP</role>'
            '</instructor>'
            '<instructor>'
            '<name>Lolas, P.</name>'
            '<firstName>Panagiotis</firstName>'
            '<middleName/>'
            '<lastName>Lolas</lastName>'
            '<sunet>panagd</sunet>'
            '<role>TA</role>'
            '</instructor>'
            '<instructor>'
            '<name>Falcone, P.</name>'
            '<firstName>Paul</firstName>'
            '<middleName>William</middleName>'
            '<lastName>Falcone</lastName>'
            '<sunet>pwfalcon</sunet>'
            '<role>TA</role>'
            '</instructor>'
            '<instructor>'
            '<name>Izzo, Z.</name>'
            '<firstName>Zachary</firstName>'
            '<middleName/>'
            '<lastName>Izzo</lastName>'
            '<sunet>zizzo</sunet>'
            '<role>TA</role>'
            '</instructor>'
            '<instructor>'
            '<name>Sprunger, C.</name>'
            '<firstName>Carsten</firstName>'
            '<middleName/>'
            '<lastName>Sprunger</lastName>'
            '<sunet>csprun</sunet>'
            '<role>TA</role>'
            '</instructor>'
            '<instructor>'
            '<name>Mueller, S.</name>'
            '<firstName>Stefan</firstName>'
            '<middleName/>'
            '<lastName>Mueller</lastName>'
            '<sunet>smu3ll3r</sunet>'
            '<role>PI</role>'
            '</instructor>'
            '</instructors>'
            '</schedule>'
            '</schedules>'
            '<currentClassSize>37</currentClassSize>'
            '<maxClassSize>55</maxClassSize>'
            '<currentWaitlistSize>0</currentWaitlistSize>'
            '<maxWaitlistSize>0</maxWaitlistSize>'
            '<notes/>'
            '<attributes>'
            '<attribute>'
            '<name>NQTR</name>'
            '<value>WIN</value>'
            '<description>Winter</description>'
            '<catalogPrint>true</catalogPrint>'
            '<schedulePrint>false</schedulePrint>'
            '</attribute>'
            '<attribute>'
            '<name>NQTR</name>'
            '<value>SUM</value>'
            '<description>Summer</description>'
            '<catalogPrint>true</catalogPrint>'
            '<schedulePrint>false</schedulePrint>'
            '</attribute>'
            '<attribute>'
            '<name>NQTR</name>'
            '<value>AUT</value>'
            '<description>Autumn</description>'
            '<catalogPrint>true</catalogPrint>'
            '<schedulePrint>false</schedulePrint>'
            '</attribute>'
            '</attributes>'
            '</section>'
            '</sections>'
            '<administrativeInformation>'
            '<courseId>117227</courseId>'
            '<effectiveStatus>A</effectiveStatus>'
            '<offerNumber>1</offerNumber>'
            '<academicGroup>HS</academicGroup>'
            '<academicOrganization>MATH</academicOrganization>'
            '<academicCareer>UG</academicCareer>'
            '<finalExamFlag>Y</finalExamFlag>'
            '<catalogPrint>Y</catalogPrint>'
            '<schedulePrint>Y</schedulePrint>'
            '<maxUnitsRepeat>3</maxUnitsRepeat>'
            '<maxTimesRepeat>1</maxTimesRepeat>'
            '</administrativeInformation>'
            '<attributes>'
            '<attribute>'
            '<name>NQTR</name>'
            '<value>WIN</value>'
            '<description>Winter</description>'
            '<catalogPrint>true</catalogPrint>'
            '<schedulePrint>false</schedulePrint>'
            '</attribute>'
            '<attribute>'
            '<name>NQTR</name>'
            '<value>SUM</value>'
            '<description>Summer</description>'
            '<catalogPrint>true</catalogPrint>'
            '<schedulePrint>false</schedulePrint>'
            '</attribute>'
            '<attribute>'
            '<name>NQTR</name>'
            '<value>AUT</value>'
            '<description>Autumn</description>'
            '<catalogPrint>true</catalogPrint>'
            '<schedulePrint>false</schedulePrint>'
            '</attribute>'
            '</attributes>'
            '<tags>'
            '<tag>'
            '<organization>EARTHSYS</organization>'
            '<name>anthro_foundation</name>'
            '</tag>'
            '<tag>'
            '<organization>EARTHSYS</organization>'
            '<name>bio_foundation</name>'
            '</tag>'
            '<tag>'
            '<organization>EARTHSYS</organization>'
            '<name>energy_foundation</name>'
            '</tag>'
            '<tag>'
            '<organization>EARTHSYS</organization>'
            '<name>land_foundation</name>'
            '</tag>'
            '<tag>'
            '<organization>EARTHSYS</organization>'
            '<name>oceans_foundation</name>'
            '</tag>'
            '<tag>'
            '<organization>ENGR</organization>'
            '<name>math</name>'
            '</tag>'
            '<tag>'
            '<organization>SPBK</organization>'
            '<name>3</name>'
            '</tag>'
            '<tag>'
            '<organization>SYMSYS</organization>'
            '<name>core</name>'
            '</tag>'
            '<tag>'
            '<organization>UAR</organization>'
            '<name>basicseq</name>'
            '</tag>'
            '<tag>'
            '<organization>REGISTRAR</organization>'
            '<name>way-fr</name>'
            '</tag>'
            '<tag>'
            '<organization>VPUE</organization>'
            '<name>ug-intro-service</name>'
            '</tag>'
            '<tag>'
            '<organization>VPUE</organization>'
            '<name>cc-ff</name>'
            '</tag>'
            '<tag>'
            '<organization>SUMCOLL</organization>'
            '<name>mathematics</name>'
            '</tag>'
            '<tag>'
            '<organization>EDUC</organization>'
            '<name>alluniversity</name>'
            '</tag>'
            '<tag>'
            '<organization>MCS</organization>'
            '<name>math_core_req</name>'
            '</tag>'
            '</tags>'
            '</course>'
        )
        text_math20 = (
            '<course>'
            '<year>2017-2018</year>'
            '<subject>MATH</subject>'
            '<code>20</code>'
            '<title>Calculus</title>'
            '<description>'
            'The definite integral, Riemann sums, antiderivatives, the '
            'Fundamental Theorem of Calculus, and the Mean Value Theorem for '
            'integrals. Integration by substitution and by parts. Area between '
            'curves, and volume by slices, washers, and shells. Initial-value '
            'problems, exponential and logistic models, direction fields, and '
            'parametric curves. Prerequisite: Math 19 or equivalent. If you '
            'have not previously taken a calculus course at Stanford then you '
            'must have taken the math placement diagnostic (offered through '
            'the Math Department website) in order to register for this course.'
            '</description>'
            '<gers>GER:DB-Math, WAY-FR</gers>'
            '<repeatable>false</repeatable>'
            '<grading>Letter or Credit/No Credit</grading>'
            '<unitsMin>3</unitsMin>'
            '<unitsMax>3</unitsMax>'
            '<learningObjectives>'
            '<learningObjective>'
            '<requirementCode>WAY-FR</requirementCode>'
            '<description>'
            'solve equations or optimization problems through translation to a '
            'standardized formalism.'
            '</description>'
            '</learningObjective>'
            '</learningObjectives>'
            '<sections>'
            '<section>'
            '<classId>16518</classId>'
            '<term>2017-2018 Autumn</term>'
            '<termId>1182</termId>'
            '<subject>MATH</subject>'
            '<code>20</code>'
            '<units>3</units>'
            '<sectionNumber>02</sectionNumber>'
            '<component>LEC</component>'
            '<numEnrolled>51</numEnrolled>'
            '<maxEnrolled>50</maxEnrolled>'
            '<numWaitlist>0</numWaitlist>'
            '<maxWaitlist>0</maxWaitlist>'
            '<enrollStatus>Closed</enrollStatus>'
            '<addConsent>N</addConsent>'
            '<dropConsent>N</dropConsent>'
            '<courseId>117229</courseId>'
            '<schedules>'
            '<schedule>'
            '<startDate>Sep 25, 2017</startDate>'
            '<endDate>Dec 8, 2017</endDate>'
            '<startTime>11:30:00 AM</startTime>'
            '<endTime>12:20:00 PM</endTime>'
            '<location>320-105</location>'
            '<days>'
            'Monday Wednesday Friday'
            '</days>'
            '<instructors>'
            '<instructor>'
            '<name>Wilson, J.</name>'
            '<firstName>Jenny</firstName>'
            '<middleName>Catherine</middleName>'
            '<lastName>Wilson</lastName>'
            '<sunet>jchw</sunet>'
            '<role>PI</role>'
            '</instructor>'
            '<instructor>'
            '<name>Cant, D.</name>'
            '<firstName>Dylan</firstName>'
            '<middleName>Jesse</middleName>'
            '<lastName>Cant</lastName>'
            '<sunet>dcant</sunet>'
            '<role>TA</role>'
            '</instructor>'
            '</instructors>'
            '</schedule>'
            '</schedules>'
            '<currentClassSize>51</currentClassSize>'
            '<maxClassSize>50</maxClassSize>'
            '<currentWaitlistSize>0</currentWaitlistSize>'
            '<maxWaitlistSize>0</maxWaitlistSize>'
            '<notes/>'
            '<attributes>'
            '<attribute>'
            '<name>NQTR</name>'
            '<value>SPR</value>'
            '<description>Spring</description>'
            '<catalogPrint>true</catalogPrint>'
            '<schedulePrint>false</schedulePrint>'
            '</attribute>'
            '<attribute>'
            '<name>NQTR</name>'
            '<value>WIN</value>'
            '<description>Winter</description>'
            '<catalogPrint>true</catalogPrint>'
            '<schedulePrint>false</schedulePrint>'
            '</attribute>'
            '<attribute>'
            '<name>NQTR</name>'
            '<value>AUT</value>'
            '<description>Autumn</description>'
            '<catalogPrint>true</catalogPrint>'
            '<schedulePrint>false</schedulePrint>'
            '</attribute>'
            '</attributes>'
            '</section>'
            '<section>'
            '<classId>30043</classId>'
            '<term>2017-2018 Autumn</term>'
            '<termId>1182</termId>'
            '<subject>MATH</subject>'
            '<code>20</code>'
            '<units>3</units>'
            '<sectionNumber>01</sectionNumber>'
            '<component>LEC</component>'
            '<numEnrolled>32</numEnrolled>'
            '<maxEnrolled>47</maxEnrolled>'
            '<numWaitlist>0</numWaitlist>'
            '<maxWaitlist>0</maxWaitlist>'
            '<enrollStatus>Open</enrollStatus>'
            '<addConsent>N</addConsent>'
            '<dropConsent>N</dropConsent>'
            '<courseId>117229</courseId>'
            '<schedules>'
            '<schedule>'
            '<startDate>Sep 25, 2017</startDate>'
            '<endDate>Dec 8, 2017</endDate>'
            '<startTime>9:30:00 AM</startTime>'
            '<endTime>10:20:00 AM</endTime>'
            '<location>200-203</location>'
            '<days>'
            'Monday Wednesday Friday'
            '</days>'
            '<instructors>'
            '<instructor>'
            '<name>Savvas, M.</name>'
            '<firstName>Michail</firstName>'
            '<middleName/>'
            '<lastName>Savvas</lastName>'
            '<sunet>msavvas</sunet>'
            '<role>PI</role>'
            '</instructor>'
            '<instructor>'
            '<name>Cant, D.</name>'
            '<firstName>Dylan</firstName>'
            '<middleName>Jesse</middleName>'
            '<lastName>Cant</lastName>'
            '<sunet>dcant</sunet>'
            '<role>TA</role>'
            '</instructor>'
            '</instructors>'
            '</schedule>'
            '</schedules>'
            '<currentClassSize>32</currentClassSize>'
            '<maxClassSize>47</maxClassSize>'
            '<currentWaitlistSize>0</currentWaitlistSize>'
            '<maxWaitlistSize>0</maxWaitlistSize>'
            '<notes/>'
            '<attributes>'
            '<attribute>'
            '<name>NQTR</name>'
            '<value>SPR</value>'
            '<description>Spring</description>'
            '<catalogPrint>true</catalogPrint>'
            '<schedulePrint>false</schedulePrint>'
            '</attribute>'
            '<attribute>'
            '<name>NQTR</name>'
            '<value>WIN</value>'
            '<description>Winter</description>'
            '<catalogPrint>true</catalogPrint>'
            '<schedulePrint>false</schedulePrint>'
            '</attribute>'
            '<attribute>'
            '<name>NQTR</name>'
            '<value>AUT</value>'
            '<description>Autumn</description>'
            '<catalogPrint>true</catalogPrint>'
            '<schedulePrint>false</schedulePrint>'
            '</attribute>'
            '</attributes>'
            '</section>'
            '<section>'
            '<classId>16519</classId>'
            '<term>2017-2018 Autumn</term>'
            '<termId>1182</termId>'
            '<subject>MATH</subject>'
            '<code>20</code>'
            '<units>3</units>'
            '<sectionNumber>03</sectionNumber>'
            '<component>LEC</component>'
            '<numEnrolled>31</numEnrolled>'
            '<maxEnrolled>45</maxEnrolled>'
            '<numWaitlist>0</numWaitlist>'
            '<maxWaitlist>0</maxWaitlist>'
            '<enrollStatus>Open</enrollStatus>'
            '<addConsent>N</addConsent>'
            '<dropConsent>N</dropConsent>'
            '<courseId>117229</courseId>'
            '<schedules>'
            '<schedule>'
            '<startDate>Sep 25, 2017</startDate>'
            '<endDate>Dec 8, 2017</endDate>'
            '<startTime>1:30:00 PM</startTime>'
            '<endTime>2:20:00 PM</endTime>'
            '<location>McCullough 115</location>'
            '<days>'
            'Monday Wednesday Friday'
            '</days>'
            '<instructors>'
            '<instructor>'
            '<name>Wilson, J.</name>'
            '<firstName>Jenny</firstName>'
            '<middleName>Catherine</middleName>'
            '<lastName>Wilson</lastName>'
            '<sunet>jchw</sunet>'
            '<role>PI</role>'
            '</instructor>'
            '<instructor>'
            '<name>Cant, D.</name>'
            '<firstName>Dylan</firstName>'
            '<middleName>Jesse</middleName>'
            '<lastName>Cant</lastName>'
            '<sunet>dcant</sunet>'
            '<role>TA</role>'
            '</instructor>'
            '</instructors>'
            '</schedule>'
            '</schedules>'
            '<currentClassSize>31</currentClassSize>'
            '<maxClassSize>45</maxClassSize>'
            '<currentWaitlistSize>0</currentWaitlistSize>'
            '<maxWaitlistSize>0</maxWaitlistSize>'
            '<notes/>'
            '<attributes>'
            '<attribute>'
            '<name>NQTR</name>'
            '<value>SPR</value>'
            '<description>Spring</description>'
            '<catalogPrint>true</catalogPrint>'
            '<schedulePrint>false</schedulePrint>'
            '</attribute>'
            '<attribute>'
            '<name>NQTR</name>'
            '<value>WIN</value>'
            '<description>Winter</description>'
            '<catalogPrint>true</catalogPrint>'
            '<schedulePrint>false</schedulePrint>'
            '</attribute>'
            '<attribute>'
            '<name>NQTR</name>'
            '<value>AUT</value>'
            '<description>Autumn</description>'
            '<catalogPrint>true</catalogPrint>'
            '<schedulePrint>false</schedulePrint>'
            '</attribute>'
            '</attributes>'
            '</section>'
            '<section>'
            '<classId>15518</classId>'
            '<term>2017-2018 Winter</term>'
            '<termId>1184</termId>'
            '<subject>MATH</subject>'
            '<code>20</code>'
            '<units>3</units>'
            '<sectionNumber>03</sectionNumber>'
            '<component>LEC</component>'
            '<numEnrolled>33</numEnrolled>'
            '<maxEnrolled>50</maxEnrolled>'
            '<numWaitlist>0</numWaitlist>'
            '<maxWaitlist>0</maxWaitlist>'
            '<enrollStatus>Open</enrollStatus>'
            '<addConsent>N</addConsent>'
            '<dropConsent>N</dropConsent>'
            '<courseId>117229</courseId>'
            '<schedules>'
            '<schedule>'
            '<startDate>Jan 8, 2018</startDate>'
            '<endDate>Mar 16, 2018</endDate>'
            '<startTime>11:30:00 AM</startTime>'
            '<endTime>12:20:00 PM</endTime>'
            '<location>380-380C</location>'
            '<days>'
            'Monday Wednesday Friday'
            '</days>'
            '<instructors>'
            '<instructor>'
            '<name>Kimport, S.</name>'
            '<firstName>Susie</firstName>'
            '<middleName/>'
            '<lastName>Kimport</lastName>'
            '<sunet>skimport</sunet>'
            '<role>GP</role>'
            '</instructor>'
            '<instructor>'
            '<name>Zhu, X.</name>'
            '<firstName>Xuwen</firstName>'
            '<middleName/>'
            '<lastName>Zhu</lastName>'
            '<sunet>xuwenzhu</sunet>'
            '<role>PI</role>'
            '</instructor>'
            '<instructor>'
            '<name>Velcheva, K.</name>'
            '<firstName>Katerina</firstName>'
            '<middleName>Krasimirova</middleName>'
            '<lastName>Velcheva</lastName>'
            '<sunet>kati13</sunet>'
            '<role>TA</role>'
            '</instructor>'
            '<instructor>'
            '<name>Lolas, P.</name>'
            '<firstName>Panagiotis</firstName>'
            '<middleName/>'
            '<lastName>Lolas</lastName>'
            '<sunet>panagd</sunet>'
            '<role>TA</role>'
            '</instructor>'
            '<instructor>'
            '<name>Guijarro Ordonez, J.</name>'
            '<firstName>Jorge</firstName>'
            '<middleName/>'
            '<lastName>Guijarro Ordonez</lastName>'
            '<sunet>jguiord</sunet>'
            '<role>TA</role>'
            '</instructor>'
            '</instructors>'
            '</schedule>'
            '</schedules>'
            '<currentClassSize>33</currentClassSize>'
            '<maxClassSize>50</maxClassSize>'
            '<currentWaitlistSize>0</currentWaitlistSize>'
            '<maxWaitlistSize>0</maxWaitlistSize>'
            '<notes/>'
            '<attributes>'
            '<attribute>'
            '<name>NQTR</name>'
            '<value>SPR</value>'
            '<description>Spring</description>'
            '<catalogPrint>true</catalogPrint>'
            '<schedulePrint>false</schedulePrint>'
            '</attribute>'
            '<attribute>'
            '<name>NQTR</name>'
            '<value>WIN</value>'
            '<description>Winter</description>'
            '<catalogPrint>true</catalogPrint>'
            '<schedulePrint>false</schedulePrint>'
            '</attribute>'
            '<attribute>'
            '<name>NQTR</name>'
            '<value>AUT</value>'
            '<description>Autumn</description>'
            '<catalogPrint>true</catalogPrint>'
            '<schedulePrint>false</schedulePrint>'
            '</attribute>'
            '</attributes>'
            '</section>'
            '<section>'
            '<classId>16434</classId>'
            '<term>2017-2018 Winter</term>'
            '<termId>1184</termId>'
            '<subject>MATH</subject>'
            '<code>20</code>'
            '<units>3</units>'
            '<sectionNumber>04</sectionNumber>'
            '<component>LEC</component>'
            '<numEnrolled>18</numEnrolled>'
            '<maxEnrolled>50</maxEnrolled>'
            '<numWaitlist>0</numWaitlist>'
            '<maxWaitlist>0</maxWaitlist>'
            '<enrollStatus>Open</enrollStatus>'
            '<addConsent>N</addConsent>'
            '<dropConsent>N</dropConsent>'
            '<courseId>117229</courseId>'
            '<schedules>'
            '<schedule>'
            '<startDate>Jan 8, 2018</startDate>'
            '<endDate>Mar 16, 2018</endDate>'
            '<startTime>1:30:00 PM</startTime>'
            '<endTime>2:20:00 PM</endTime>'
            '<location>380-380C</location>'
            '<days>'
            'Monday Wednesday Friday'
            '</days>'
            '<instructors>'
            '<instructor>'
            '<name>Kimport, S.</name>'
            '<firstName>Susie</firstName>'
            '<middleName/>'
            '<lastName>Kimport</lastName>'
            '<sunet>skimport</sunet>'
            '<role>GP</role>'
            '</instructor>'
            '<instructor>'
            '<name>Velcheva, K.</name>'
            '<firstName>Katerina</firstName>'
            '<middleName>Krasimirova</middleName>'
            '<lastName>Velcheva</lastName>'
            '<sunet>kati13</sunet>'
            '<role>TA</role>'
            '</instructor>'
            '<instructor>'
            '<name>Savvas, M.</name>'
            '<firstName>Michail</firstName>'
            '<middleName/>'
            '<lastName>Savvas</lastName>'
            '<sunet>msavvas</sunet>'
            '<role>PI</role>'
            '</instructor>'
            '<instructor>'
            '<name>Lolas, P.</name>'
            '<firstName>Panagiotis</firstName>'
            '<middleName/>'
            '<lastName>Lolas</lastName>'
            '<sunet>panagd</sunet>'
            '<role>TA</role>'
            '</instructor>'
            '<instructor>'
            '<name>Guijarro Ordonez, J.</name>'
            '<firstName>Jorge</firstName>'
            '<middleName/>'
            '<lastName>Guijarro Ordonez</lastName>'
            '<sunet>jguiord</sunet>'
            '<role>TA</role>'
            '</instructor>'
            '</instructors>'
            '</schedule>'
            '</schedules>'
            '<currentClassSize>18</currentClassSize>'
            '<maxClassSize>50</maxClassSize>'
            '<currentWaitlistSize>0</currentWaitlistSize>'
            '<maxWaitlistSize>0</maxWaitlistSize>'
            '<notes/>'
            '<attributes>'
            '<attribute>'
            '<name>NQTR</name>'
            '<value>SPR</value>'
            '<description>Spring</description>'
            '<catalogPrint>true</catalogPrint>'
            '<schedulePrint>false</schedulePrint>'
            '</attribute>'
            '<attribute>'
            '<name>NQTR</name>'
            '<value>WIN</value>'
            '<description>Winter</description>'
            '<catalogPrint>true</catalogPrint>'
            '<schedulePrint>false</schedulePrint>'
            '</attribute>'
            '<attribute>'
            '<name>NQTR</name>'
            '<value>AUT</value>'
            '<description>Autumn</description>'
            '<catalogPrint>true</catalogPrint>'
            '<schedulePrint>false</schedulePrint>'
            '</attribute>'
            '</attributes>'
            '</section>'
            '<section>'
            '<classId>10211</classId>'
            '<term>2017-2018 Winter</term>'
            '<termId>1184</termId>'
            '<subject>MATH</subject>'
            '<code>20</code>'
            '<units>3</units>'
            '<sectionNumber>02</sectionNumber>'
            '<component>LEC</component>'
            '<numEnrolled>66</numEnrolled>'
            '<maxEnrolled>70</maxEnrolled>'
            '<numWaitlist>0</numWaitlist>'
            '<maxWaitlist>0</maxWaitlist>'
            '<enrollStatus>Open</enrollStatus>'
            '<addConsent>N</addConsent>'
            '<dropConsent>N</dropConsent>'
            '<courseId>117229</courseId>'
            '<schedules>'
            '<schedule>'
            '<startDate>Jan 8, 2018</startDate>'
            '<endDate>Mar 16, 2018</endDate>'
            '<startTime>10:30:00 AM</startTime>'
            '<endTime>11:20:00 AM</endTime>'
            '<location>380-380C</location>'
            '<days>'
            'Monday Wednesday Friday'
            '</days>'
            '<instructors>'
            '<instructor>'
            '<name>Kimport, S.</name>'
            '<firstName>Susie</firstName>'
            '<middleName/>'
            '<lastName>Kimport</lastName>'
            '<sunet>skimport</sunet>'
            '<role>PI</role>'
            '</instructor>'
            '<instructor>'
            '<name>Velcheva, K.</name>'
            '<firstName>Katerina</firstName>'
            '<middleName>Krasimirova</middleName>'
            '<lastName>Velcheva</lastName>'
            '<sunet>kati13</sunet>'
            '<role>TA</role>'
            '</instructor>'
            '<instructor>'
            '<name>Lolas, P.</name>'
            '<firstName>Panagiotis</firstName>'
            '<middleName/>'
            '<lastName>Lolas</lastName>'
            '<sunet>panagd</sunet>'
            '<role>TA</role>'
            '</instructor>'
            '<instructor>'
            '<name>Guijarro Ordonez, J.</name>'
            '<firstName>Jorge</firstName>'
            '<middleName/>'
            '<lastName>Guijarro Ordonez</lastName>'
            '<sunet>jguiord</sunet>'
            '<role>TA</role>'
            '</instructor>'
            '</instructors>'
            '</schedule>'
            '</schedules>'
            '<currentClassSize>66</currentClassSize>'
            '<maxClassSize>70</maxClassSize>'
            '<currentWaitlistSize>0</currentWaitlistSize>'
            '<maxWaitlistSize>0</maxWaitlistSize>'
            '<notes/>'
            '<attributes>'
            '<attribute>'
            '<name>NQTR</name>'
            '<value>SPR</value>'
            '<description>Spring</description>'
            '<catalogPrint>true</catalogPrint>'
            '<schedulePrint>false</schedulePrint>'
            '</attribute>'
            '<attribute>'
            '<name>NQTR</name>'
            '<value>WIN</value>'
            '<description>Winter</description>'
            '<catalogPrint>true</catalogPrint>'
            '<schedulePrint>false</schedulePrint>'
            '</attribute>'
            '<attribute>'
            '<name>NQTR</name>'
            '<value>AUT</value>'
            '<description>Autumn</description>'
            '<catalogPrint>true</catalogPrint>'
            '<schedulePrint>false</schedulePrint>'
            '</attribute>'
            '</attributes>'
            '</section>'
            '<section>'
            '<classId>10210</classId>'
            '<term>2017-2018 Winter</term>'
            '<termId>1184</termId>'
            '<subject>MATH</subject>'
            '<code>20</code>'
            '<units>3</units>'
            '<sectionNumber>01</sectionNumber>'
            '<component>LEC</component>'
            '<numEnrolled>67</numEnrolled>'
            '<maxEnrolled>70</maxEnrolled>'
            '<numWaitlist>0</numWaitlist>'
            '<maxWaitlist>0</maxWaitlist>'
            '<enrollStatus>Open</enrollStatus>'
            '<addConsent>N</addConsent>'
            '<dropConsent>N</dropConsent>'
            '<courseId>117229</courseId>'
            '<schedules>'
            '<schedule>'
            '<startDate>Jan 8, 2018</startDate>'
            '<endDate>Mar 16, 2018</endDate>'
            '<startTime>9:30:00 AM</startTime>'
            '<endTime>10:20:00 AM</endTime>'
            '<location>380-380C</location>'
            '<days>'
            'Monday Wednesday Friday'
            '</days>'
            '<instructors>'
            '<instructor>'
            '<name>Kimport, S.</name>'
            '<firstName>Susie</firstName>'
            '<middleName/>'
            '<lastName>Kimport</lastName>'
            '<sunet>skimport</sunet>'
            '<role>PI</role>'
            '</instructor>'
            '<instructor>'
            '<name>Velcheva, K.</name>'
            '<firstName>Katerina</firstName>'
            '<middleName>Krasimirova</middleName>'
            '<lastName>Velcheva</lastName>'
            '<sunet>kati13</sunet>'
            '<role>TA</role>'
            '</instructor>'
            '<instructor>'
            '<name>Lolas, P.</name>'
            '<firstName>Panagiotis</firstName>'
            '<middleName/>'
            '<lastName>Lolas</lastName>'
            '<sunet>panagd</sunet>'
            '<role>TA</role>'
            '</instructor>'
            '<instructor>'
            '<name>Guijarro Ordonez, J.</name>'
            '<firstName>Jorge</firstName>'
            '<middleName/>'
            '<lastName>Guijarro Ordonez</lastName>'
            '<sunet>jguiord</sunet>'
            '<role>TA</role>'
            '</instructor>'
            '</instructors>'
            '</schedule>'
            '</schedules>'
            '<currentClassSize>67</currentClassSize>'
            '<maxClassSize>70</maxClassSize>'
            '<currentWaitlistSize>0</currentWaitlistSize>'
            '<maxWaitlistSize>0</maxWaitlistSize>'
            '<notes/>'
            '<attributes>'
            '<attribute>'
            '<name>NQTR</name>'
            '<value>SPR</value>'
            '<description>Spring</description>'
            '<catalogPrint>true</catalogPrint>'
            '<schedulePrint>false</schedulePrint>'
            '</attribute>'
            '<attribute>'
            '<name>NQTR</name>'
            '<value>WIN</value>'
            '<description>Winter</description>'
            '<catalogPrint>true</catalogPrint>'
            '<schedulePrint>false</schedulePrint>'
            '</attribute>'
            '<attribute>'
            '<name>NQTR</name>'
            '<value>AUT</value>'
            '<description>Autumn</description>'
            '<catalogPrint>true</catalogPrint>'
            '<schedulePrint>false</schedulePrint>'
            '</attribute>'
            '</attributes>'
            '</section>'
            '<section>'
            '<classId>10670</classId>'
            '<term>2017-2018 Spring</term>'
            '<termId>1186</termId>'
            '<subject>MATH</subject>'
            '<code>20</code>'
            '<units>3</units>'
            '<sectionNumber>01</sectionNumber>'
            '<component>LEC</component>'
            '<numEnrolled>54</numEnrolled>'
            '<maxEnrolled>60</maxEnrolled>'
            '<numWaitlist>0</numWaitlist>'
            '<maxWaitlist>0</maxWaitlist>'
            '<enrollStatus>Open</enrollStatus>'
            '<addConsent>N</addConsent>'
            '<dropConsent>N</dropConsent>'
            '<courseId>117229</courseId>'
            '<schedules>'
            '<schedule>'
            '<startDate>Apr 2, 2018</startDate>'
            '<endDate>Jun 6, 2018</endDate>'
            '<startTime>1:30:00 PM</startTime>'
            '<endTime>2:20:00 PM</endTime>'
            '<location>200-203</location>'
            '<days>'
            'Monday Wednesday Friday'
            '</days>'
            '<instructors>'
            '<instructor>'
            '<name>Madnick, J.</name>'
            '<firstName>Jesse</firstName>'
            '<middleName>Ochs</middleName>'
            '<lastName>Madnick</lastName>'
            '<sunet>jmadnick</sunet>'
            '<role>PI</role>'
            '</instructor>'
            '<instructor>'
            '<name>Zhou, Z.</name>'
            '<firstName>Zhengqing</firstName>'
            '<middleName/>'
            '<lastName>Zhou</lastName>'
            '<sunet>zqzhou</sunet>'
            '<role>TA</role>'
            '</instructor>'
            '<instructor>'
            '<name>Cant, D.</name>'
            '<firstName>Dylan</firstName>'
            '<middleName>Jesse</middleName>'
            '<lastName>Cant</lastName>'
            '<sunet>dcant</sunet>'
            '<role>TA</role>'
            '</instructor>'
            '</instructors>'
            '</schedule>'
            '</schedules>'
            '<currentClassSize>54</currentClassSize>'
            '<maxClassSize>60</maxClassSize>'
            '<currentWaitlistSize>0</currentWaitlistSize>'
            '<maxWaitlistSize>0</maxWaitlistSize>'
            '<notes/>'
            '<attributes>'
            '<attribute>'
            '<name>NQTR</name>'
            '<value>SPR</value>'
            '<description>Spring</description>'
            '<catalogPrint>true</catalogPrint>'
            '<schedulePrint>false</schedulePrint>'
            '</attribute>'
            '<attribute>'
            '<name>NQTR</name>'
            '<value>WIN</value>'
            '<description>Winter</description>'
            '<catalogPrint>true</catalogPrint>'
            '<schedulePrint>false</schedulePrint>'
            '</attribute>'
            '<attribute>'
            '<name>NQTR</name>'
            '<value>AUT</value>'
            '<description>Autumn</description>'
            '<catalogPrint>true</catalogPrint>'
            '<schedulePrint>false</schedulePrint>'
            '</attribute>'
            '</attributes>'
            '</section>'
            '</sections>'
            '<administrativeInformation>'
            '<courseId>117229</courseId>'
            '<effectiveStatus>A</effectiveStatus>'
            '<offerNumber>1</offerNumber>'
            '<academicGroup>HS</academicGroup>'
            '<academicOrganization>MATH</academicOrganization>'
            '<academicCareer>UG</academicCareer>'
            '<finalExamFlag>Y</finalExamFlag>'
            '<catalogPrint>Y</catalogPrint>'
            '<schedulePrint>Y</schedulePrint>'
            '<maxUnitsRepeat>3</maxUnitsRepeat>'
            '<maxTimesRepeat>1</maxTimesRepeat>'
            '</administrativeInformation>'
            '<attributes>'
            '<attribute>'
            '<name>NQTR</name>'
            '<value>SPR</value>'
            '<description>Spring</description>'
            '<catalogPrint>true</catalogPrint>'
            '<schedulePrint>false</schedulePrint>'
            '</attribute>'
            '<attribute>'
            '<name>NQTR</name>'
            '<value>WIN</value>'
            '<description>Winter</description>'
            '<catalogPrint>true</catalogPrint>'
            '<schedulePrint>false</schedulePrint>'
            '</attribute>'
            '<attribute>'
            '<name>NQTR</name>'
            '<value>AUT</value>'
            '<description>Autumn</description>'
            '<catalogPrint>true</catalogPrint>'
            '<schedulePrint>false</schedulePrint>'
            '</attribute>'
            '</attributes>'
            '<tags>'
            '<tag>'
            '<organization>EARTHSYS</organization>'
            '<name>anthro_foundation</name>'
            '</tag>'
            '<tag>'
            '<organization>EARTHSYS</organization>'
            '<name>bio_foundation</name>'
            '</tag>'
            '<tag>'
            '<organization>EARTHSYS</organization>'
            '<name>energy_foundation</name>'
            '</tag>'
            '<tag>'
            '<organization>EARTHSYS</organization>'
            '<name>land_foundation</name>'
            '</tag>'
            '<tag>'
            '<organization>EARTHSYS</organization>'
            '<name>oceans_foundation</name>'
            '</tag>'
            '<tag>'
            '<organization>ENGR</organization>'
            '<name>math</name>'
            '</tag>'
            '<tag>'
            '<organization>SPBK</organization>'
            '<name>3</name>'
            '</tag>'
            '<tag>'
            '<organization>SYMSYS</organization>'
            '<name>core</name>'
            '</tag>'
            '<tag>'
            '<organization>UAR</organization>'
            '<name>basicseq</name>'
            '</tag>'
            '<tag>'
            '<organization>VPUE</organization>'
            '<name>ug-intro-service</name>'
            '</tag>'
            '<tag>'
            '<organization>EDUC</organization>'
            '<name>alluniversity</name>'
            '</tag>'
            '<tag>'
            '<organization>MCS</organization>'
            '<name>math_core_req</name>'
            '</tag>'
            '</tags>'
            '</course>'
        )
        
        cls.xml_math19 = ET.fromstring(text_math19)
        cls.xml_math20 = ET.fromstring(text_math20)


    def test_create_course(self):
        course = Course(self.xml_math19)

        assert course != None


    def test_course_attributes(self):
        course = Course(self.xml_math20)

        assert course.year == "2017-2018"
        assert course.subject == "MATH"
        assert course.code == "20"
        assert course.title == "Calculus"
        assert course.description == (
            "The definite integral, Riemann sums, antiderivatives, the "
            "Fundamental Theorem of Calculus, and the Mean Value Theorem for "
            "integrals. Integration by substitution and by parts. Area between "
            "curves, and volume by slices, washers, and shells. Initial-value "
            "problems, exponential and logistic models, direction fields, and "
            "parametric curves. Prerequisite: Math 19 or equivalent. If you "
            "have not previously taken a calculus course at Stanford then you "
            "must have taken the math placement diagnostic (offered through "
            "the Math Department website) in order to register for this course."
        )
        assert course.gers == ("GER:DB-Math", "WAY-FR")
        assert course.repeatable == False
        assert course.grading_basis == "Letter or Credit/No Credit"
        assert course.units_min == 3
        assert course.units_max == 3
        assert len(course.objectives) == 1 
        assert course.final_exam == True
        assert len(course.sections) == 8
        assert len(course.tags) == 12
        assert len(course.attributes) == 3
        assert course.course_id == 117229
        assert course.active == True
        assert course.offer_num == "1"
        assert course.academic_group == "HS"
        assert course.academic_org == "MATH"
        assert course.academic_career == "UG"
        assert course.max_units_repeat == 3
        assert course.max_times_repeat == 1


    def test_course_string(self):
        course = Course(self.xml_math20)

        assert str(course) == "MATH20 Calculus"


    def test_course_comparisons(self):
        math19 = Course(self.xml_math19)
        math20 = Course(self.xml_math20)

        assert math19 == Course(self.xml_math19)
        assert math20 > math19
        assert math19 < math20
        assert math20 >= math20
        assert math19 <= math19
